'******************************************************************************
'*  trs80_render.spin - Render a TRS80 video RAM into a 12 scanlines bitmap
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id: yaz80_demo.spin,v 1.8 2010-03-21 12:43:11 pm Exp $
'******************************************************************************

VAR
	long	cog

PUB start(params) : okay
	stop

	okay := cog := COGNEW(@entry, params) + 1

PUB stop
	if cog
		COGSTOP(cog - 1)
		cog := 0

DAT
entry
		jmp	#startup

				' chr($00)
'		byte	$00	' ........
'		byte	$3e	' .#####..
'		byte	$22	' .#...#..
'		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($01)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($02)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($03)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($04)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$3c	' ..####..
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$20	' .....#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($05)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$36	' .##.##..
		byte	$2a	' .#.#.#..
		byte	$36	' .##.##..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($06)
		byte	$00	' ........
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$0a	' .#.#....
		byte	$06	' .##.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($07)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$36	' .##.##..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($08)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$1e	' .####...
		byte	$24	' ..#..#..
		byte	$28	' ...#.#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($09)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($0a)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($0b)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($0c)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($0d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$3e	' .#####..
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($0e)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$36	' .##.##..
		byte	$2a	' .#.#.#..
		byte	$36	' .##.##..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($0f)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($10)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($11)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3a	' .#.###..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($12)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3a	' .#.###..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($13)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2e	' .###.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($14)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2e	' .###.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($15)
		byte	$00	' ........
		byte	$00	' ........
		byte	$28	' ...#.#..
		byte	$10	' ....#...
		byte	$2a	' .#.#.#..
		byte	$06	' .##.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($16)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$36	' .##.##..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($17)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$3e	' .#####..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($18)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($19)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($1a)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($1b)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($1c)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2e	' .###.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($1d)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2e	' .###.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($1e)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3a	' .#.###..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($1f)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3a	' .#.###..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($20)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($21)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($22)
		byte	$00	' ........
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($23)
		byte	$00	' ........
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$3e	' .#####..
		byte	$14	' ..#.#...
		byte	$3e	' .#####..
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($24)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$3c	' ..####..
		byte	$0a	' .#.#....
		byte	$1c	' ..###...
		byte	$28	' ...#.#..
		byte	$1e	' .####...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($25)
		byte	$00	' ........
		byte	$06	' .##.....
		byte	$26	' .##..#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$32	' .#..##..
		byte	$30	' ....##..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($26)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$0a	' .#.#....
		byte	$0a	' .#.#....
		byte	$04	' ..#.....
		byte	$2a	' .#.#.#..
		byte	$12	' .#..#...
		byte	$2c	' ..##.#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($27)
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($28)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$04	' ..#.....
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($29)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$10	' ....#...
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2a)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$3e	' .#####..
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2b)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$3e	' .#####..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2c)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2e)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2f)
		byte	$00	' ........
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($30)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2a	' .#.#.#..
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($31)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$0c	' ..##....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($32)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$1c	' ..###...
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($33)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$18	' ...##...
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($34)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$18	' ...##...
		byte	$14	' ..#.#...
		byte	$12	' .#..#...
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($35)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$1e	' .####...
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($36)
		byte	$00	' ........
		byte	$18	' ...##...
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$1e	' .####...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($37)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($38)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($39)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3c	' ..####..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($3a)
		byte	$00	' ........
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($3b)
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($3c)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($3d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($3e)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($3f)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($40)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$2c	' ..##.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($41)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($42)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$1c	' ..###...
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$1e	' .####...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($43)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($44)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$1e	' .####...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($45)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$0e	' .###....
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($46)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$0e	' .###....
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($47)
		byte	$00	' ........
		byte	$3c	' ..####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3c	' ..####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($48)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($49)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($4a)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($4b)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$12	' .#..#...
		byte	$0a	' .#.#....
		byte	$06	' .##.....
		byte	$0a	' .#.#....
		byte	$12	' .#..#...
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($4c)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($4d)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$36	' .##.##..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($4e)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$26	' .##..#..
		byte	$2a	' .#.#.#..
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($4f)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($50)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1e	' .####...
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($51)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$12	' .#..#...
		byte	$2c	' ..##.#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($52)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1e	' .####...
		byte	$0a	' .#.#....
		byte	$12	' .#..#...
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($53)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$1c	' ..###...
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($54)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($55)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($56)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($57)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$36	' .##.##..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($58)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($59)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($5a)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($5b)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($5c)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($5d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$3e	' .#####..
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($5e)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($5f)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($60)
		byte	$00	' ........
		byte	$18	' ...##...
		byte	$18	' ...##...
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($61)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$20	' .....#..
		byte	$3c	' ..####..
		byte	$22	' .#...#..
		byte	$3c	' ..####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($62)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$26	' .##..#..
		byte	$1a	' .#.##...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($63)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($64)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$2c	' ..##.#..
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($65)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($66)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$28	' ...#.#..
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($67)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$2c	' ..##.#..
		byte	$32	' .#..##..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........

				' chr($68)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($69)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($6a)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($6b)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$12	' .#..#...
		byte	$0a	' .#.#....
		byte	$06	' .##.....
		byte	$0a	' .#.#....
		byte	$12	' .#..#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($6c)
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($6d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$16	' .##.#...
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($6e)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($6f)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($70)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$26	' .##..#..
		byte	$1a	' .#.##...
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........

				' chr($71)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$2c	' ..##.#..
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$00	' ........
		byte	$00	' ........

				' chr($72)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($73)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3c	' ..####..
		byte	$02	' .#......
		byte	$1c	' ..###...
		byte	$20	' .....#..
		byte	$1e	' .####...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($74)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$3e	' .#####..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$28	' ...#.#..
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($75)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($76)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($77)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($78)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($79)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3c	' ..####..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$00	' ........
		byte	$00	' ........

				' chr($7a)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($7b)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($7c)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($7d)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($7e)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$2a	' .#.#.#..
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($7f)
		byte	$00	' ........
		byte	$14	' ..#.#...
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

chr0
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
gfx
		byte	$00	' ........
		byte	$38	' ..###...
		byte	$07	' .....###
		byte	$3f	' ..######

startup
		mov	entry, chr0

		mov	t1, PAR				' pointer to 4 longs (sync, screen, bitmaps, tvPin)
		rdlong	sync_ptr, t1			' get address of sync long
		add	t1, #4
		rdlong	video_ptr, t1			' get address of video buffer
		add	t1, #4
		rdlong	bitmap_ptr, t1			' get address of bitmap buffer
		add	bitmap_end, bitmap_ptr

render_frame
		mov	charptr0, video_ptr
		mov	bmapptr, bitmap_ptr
		mov	longindex, #0
		mov	longshift, #0
		mov	rows, #16*12
		mov	scanrow, #0
render_row
' wait for video cog to be finished with the other bitmap

		mov	charptr, charptr0
		mov	cols, #64

render_col
		rdbyte	ch, charptr			' get character code
		add	charptr, #1
		cmp	ch, #$80		WZ, WC	' block graphics?
	if_ae	jmp	#block_gfx	

		mov	t1, ch				' char * 3 = long address in chargen
		shl	ch, #1
		add	ch, t1
		add	ch, longindex			' index 1st, 2nd or 3rd long per character
		movs	:chrgen, ch
		nop
:chrgen		mov	bits, 0-0			' get bits
		shr	bits, longshift			' shift 0, 8, 16 or 24 times
render_bits
		shl	bits, #32-6
		shr	out, #6				' shift 6 bits into accu
		or	out, bits			' paste 6 new bits in 1st accu
		add	outcnt, #6			' 6 more bits in the 32 bit accu
		cmp	outcnt, #16		WC	' do we have a complete word?
	if_b	jmp	#:next
		mov	t1, #32
		sub	t1, outcnt
		shr	out, t1
		wrword	out, bmapptr			' yes, write it to the bitmap
		shl	out, t1
		add	bmapptr, #2			' next destination address
		sub	outcnt, #16			' subtract 16 bits
:next
		djnz	cols, #render_col

		cmp	bmapptr, bitmap_end	WZ	' ... re-start the bitmap pointer?
	if_z	mov	bmapptr, bitmap_ptr
	if_z	add	scanrow, #1
:wait		rdlong	t1, sync_ptr
		cmp	t1, scanrow		WC
	if_b	jmp	#:wait

		add	longshift, #8			' shift count += 8
		and	longshift, #24		WZ	' next long of the chargen?
	if_z	add	longindex, #1			' use 2nd long from chargen next time, or blank bits 3rd time
	if_z	cmp	longindex, #3		WZ	' next character row?
	if_z	mov	longindex, #0			' reset longindex
	if_z	add	charptr0, #64			' next row of characters after video_ptr

		djnz	rows, #render_row		' do the next scanline row

		jmp	#render_frame			' next frame

block_gfx
		shr	ch, longindex			' shift the active bits
		shr	ch, longindex			' intro ch 1..0
		and	ch, #3				' mask 1..0
		shl	ch, #3				' * 8 gives 0, 8, 16 or 24
		mov	bits, gfx			' fetch the pixel bit mask
		shr	bits, ch
		jmp	#render_bits			' continue just as with chargen data

'******************************************************************************

video_ptr	long	0-0				' pointer to 64x16 bytes video RAM
bitmap_ptr	long	0-0				' pointer to 64x6x2 bits bitmap buffer
bitmap_end	long	12*64*6/8			' number of bytes in the bitmap buffers
sync_ptr	long	0-0				' pointer to the render / video synchronization

scanrow		long	0				' active character row
longshift	long	0				' long shift value for the chargen longs
longindex	long	0				' index of font long
charptr0	long	0				' per character row pointer into video_ptr
charptr		long	0				' per scanline pointer into video_ptr
bmapptr		long	0				' bitmap buffer pointer per column
ch		long    0
bits		long    0
out		long	0				' pixel accumulator
outcnt		long	0				' number of bits in both accumulators
rows		long    0				' loop counter - number of rows
cols		long    0				' loop counter - number of columns
t1		long    0
null		long	0


		fit	$1f0
